## Script (Python) "createReturningStudent"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=matric_no=None
##title=
##
# $Id: createReturningStudent.py 1151 2006-12-29 22:05:53Z joachim $
''' create the Studentbase folder'''


pm = context.portal_membership
member = pm.getAuthenticatedMember()
wftool = context.portal_workflow
students_folder = context.portal_url.getPortalObject().campus.students
import logging
logger = logging.getLogger('createReturningStudent')

if not matric_no:
    return "No MatricNo"

if matric_no != 'All':
    if context.students_catalog(matric_no=matric_no):
        return "Student with %s already exists" % matric_no
    res = context.returning_import(matric_no = matric_no)
    if len(res) != 1:
        return "MatricNo %s not found in Returning Table" % matric_no
    student_brain = res[0]
    sid,jamb_reg_no = context.waeup_tool.createOne(students_folder,student_brain,'?')
    logger.info('"%s","Created Student","%s", "%s" ' % (member,sid,matric_no))
    return "Student MatricNo %s, StudentId %s Jamb %s created" % (matric_no,sid,jamb_reg_no)

students = context.returning_import(emil="adf")
count = 1
total = 0
logger.info('"%s","Create Students start"' % (member))
#from Products.zdb import set_trace;set_trace()
for student in students:
    if context.students_catalog(matric_no=student.matric_no):
        logger.info('"Student already exists","%s"' % (student.matric_no))
        continue
    if count > 100:
        context.waeup_tool.createOne(students_folder,student,'Z',commit=True)
        logger.info('"%s","Committed Students","%s", "%s" ' % (member,count,total))
        total += count
        count = 1
        if total > 500:
            break
    else:
        for letter in ('ABCDEFGHKLMNPQRSTUVWXY'):
            context.waeup_tool.createOne(students_folder,student,letter)
            count += 1
logger.info('"%s","Create Students finish","%s"' % (member,total))
